C-----------------------------------------------------------------
c     This Soubroutine calculates Hessian matrix for current NN
c	Architecture based on current weight values.
C-----------------------------------------------------------------  
	SUBROUTINE HYPERPARAMETERS
      INCLUDE 'header.txt'       
	         
      dimension testsum(2,50),testact(2,50)
      dimension testdact(2,50),testddact(2,50)
      dimension tbjack(500),derr(nop)
      real alphaold,betaold,delta,propsum1,propsum2,wtsum
      ahessian(1:500,1:500)=0.0
      bjack(1:500)=0.0
      derr(1:nop)=0.0
      hessian(1:500,1:500)=0.0      
      tbjack(1:500)=0.0
      testsum(1:2,1:50)=0.0
      testact(1:2,1:50)=0.0
      testdact(1:2,1:50)=0.0
      testddact(1:2,1:50)=0.0        
      delta=0.0
      errorwt=0.0 
	errordata=0.0

C     Calculation of Error(wt & data) terms 
      do 10 ii=1,nhid
		errorwt=errorwt+(wtbh(ii))*(wtbh(ii))
 10   continue      
      do 15 ii=1,nip
		do 15 ij=1,nhid
		errorwt=errorwt+(wtih(ii,ij))*(wtih(ii,ij))
 15   continue
      do 20 ii=1,nhid
		do 20 ij=1,nop
		errorwt=errorwt+(wtho(ii,ij))*(wtho(ii,ij))
 20   continue 
		errorwt=0.5*errorwt              
                      
      do 25 ii=1,ntrndat
		do 30 ij=1,nhid
		testsum(1,ij)=bias*wtbh(ij)
	1				  +sum(wtih(1:nip,ij)*xnorm(ii,1:nip))
		if (inp_act.eq.1) then
			testact(1,ij)=1/(1+exp(-testsum(1,ij)))
		elseif (inp_act.eq.2) then
			testact(1,ij)=(exp(testsum(1,ij))-exp(-testsum(1,ij)))
     1					 /(exp(testsum(1,ij))+exp(-testsum(1,ij)))
		endif
 30		continue
		do 40 ij=1,nop		
			testsum(2,ij)=sum(wtho(1:nhid,ij)*testact(1,1:nhid))
		if (inp_act.eq.1) then
			testact(2,ij)=1/(1+exp(-testsum(2,ij)))
		elseif (inp_act.eq.2) then
			testact(2,ij)=(exp(testsum(2,ij))-exp(-testsum(2,ij)))
     1					 /(exp(testsum(2,ij))+exp(-testsum(2,ij)))
		endif		   
 40		continue
		do 45 ij=1,nop
		errordata=errordata+(testact(2,ij)-ynorm(ii,ij))**2
 45		continue
 25   continue
		errordata=0.5*errordata
 
      testsum(1:2,1:50)=0.0
      testact(1:2,1:50)=0.0
      testdact(1:2,1:50)=0.0
      testddact(1:2,1:50)=0.0             
C	Calculation of Hessian matrix       
      do 50 ii=1,ntrndat      
	bjack(1:300)=0.0
	tbjack(1:300)=0.0
		do 55 ij=1,nhid        
			testsum(1,ij)=bias*wtbh(ij)+
     1					  sum(wtih(1:nip,ij)*xnorm(ii,1:nip))
			testact(1,ij)=(exp(testsum(1,ij))-exp(-testsum(1,ij)))
     1					 /(exp(testsum(1,ij))+exp(-testsum(1,ij)))
			testdact(1,ij)=1-(testact(1,ij)*testact(1,ij))
 55		continue
		do 60 ij=1,nop
			testsum(2,ij)=sum(wtho(1:nhid,ij)*testact(1,1:nhid))
			testact(2,ij)=(exp(testsum(2,ij))-exp(-testsum(2,ij)))
     1					 /(exp(testsum(2,ij))+exp(-testsum(2,ij)))
			testdact(2,ij)=1-(testact(2,ij)*testact(2,ij))
 60		continue    
	derr(1:nop)=ynorm(ii,1:nop)-testact(2,1:nop) 
	im=1      
		if (nadbias.eq.1) then						! Bias-h/d
		do 65 ir=1,nbias
			do 65 ic=1,nhid                
			bjack(im)=bjack(im)+(-1.0)*sum(derr(1:nop)
     1						   *(testdact(2,1:nop)*wtho(ic,1:nop)))
     1						   *testdact(1,ic)*bias
			tbjack(im)=tbjack(im)+sum((testdact(2,1:nop)*wtho(ic,1:nop)))
     1							 *testdact(1,ic)*bias
      im=im+1              
 65		continue
		endif
		do 70 ir=1,nip								! ip-hd
			do 70 ic=1,nhid                
			bjack(im)=bjack(im)+(-1.0)*sum(derr(1:nop)
     1						   *(testdact(2,1:nop)*wtho(ic,1:nop)))
     1						   *testdact(1,ic)*xnorm(ii,ir)
			tbjack(im)=tbjack(im)+sum((testdact(2,1:nop)*wtho(ic,1:nop)))
     1							 *testdact(1,ic)*xnorm(ii,ir)
      im=im+1              
 70		continue
		do 75 ir=1,nhid								! hd-op
			do 75 ic=1,nop                
			bjack(im)=bjack(im)+(-1.0)*derr(ic)*testdact(2,ic)
     1					       *testact(1,ir) 
			tbjack(im)=tbjack(im)+testdact(2,ic)*testact(1,ir) 
      im=im+1
 75		continue  

c	Calculation of terms in the Hessian matrix 
		do 80 ir=1,nwts  
			do 80 ic=1,nwts     
			hessian(ir,ic)=hessian(ir,ic)+tbjack(ir)*tbjack(ic)
 80		continue 
 50   continue      

c	Calculation of regularised hessian matrix      
		ahessian(1:nwts,1:nwts)=beta*(hessian(1:nwts,1:nwts))      
      do 85 ir=1,nwts
		ahessian(ir,ir)= ahessian(ir,ir)+alpha1
 85   continue 

      return
      END SUBROUTINE HYPERPARAMETERS

