C-------------------------------------------------------------------
c	Subroutine for calculation of Inverse of a matrix
c	Here Inverse of Hessian Matrix 
C-------------------------------------------------------------------
      SUBROUTINE AHESINV
      INCLUDE 'header.txt'      

      dimension tempmat(500,500)
      real temp   
      tempmat(1:500,1:500)=0.0
      ahessianinv(1:500,1:500)=0.0
      coef=0.0
      trace=0.0
      
      do 95 ir = 1, nwts
		do 95 ic = 1, 2*nwts
		if (ic.le.nwts) then
			tempmat(ir,ic)=ahessian(ir,ic)
		elseif ((ir+nwts).eq.ic) then
			tempmat(ir,ic) = 1.0
		else
			tempmat(ir,ic) = 0.0
		endif
 95   continue

c     Converting it to upper triangular matrix

      do 10 k = 1,nwts-1
		do 10 ir = k+1,nwts                        
			coef = tempmat(ir,k)/tempmat(k,k)
		do 10 ic = k,(2*nwts)
			tempmat(ir,ic) = tempmat(ir,ic)- coef*tempmat(k,ic)
 10   continue      

c     Make diagonal elements as 1

      do 15 ir = 1,nwts
		coef = tempmat(ir,ir)
      do 15 ic = ir,(2*nwts)                               
		tempmat(ir,ic) = (tempmat(ir,ic)/coef)              
 15   continue      
      
c     Reduced right side half of augmented matrix to identity matrix

      do 20 k = nwts,2,-1
		do 20 ir = k-1,1,-1
		coef= tempmat(ir,k)
		do 20 ic = 1,(2*nwts)
     			tempmat(ir,ic) = tempmat(ir,ic)-(tempmat(k,ic)*coef)
 20   continue
	do 25 ir = 1,nwts
		do 25 ic = 1,nwts
		ahessianinv(ir,ic) = tempmat(ir,ic+nwts)
 25   continue

      return
      END SUBROUTINE AHESINV

