	SUBROUTINE INPUT
	INCLUDE 'header.txt'

	open(unit=31,FILE='./input.txt')

c	Reading no. of input nodes, hidden nodes and output nodes
	
	read(31,*)			 !reading the comment line in input file
	read(31,*)			 !reading the blank line in input file	
	read(31,*)nip        !reading no. of input nodes
	read(31,*)nop        !reading no. of output nodes
	read(31,*)			 !reading the blank line in input file	
	read(31,*)			 !reading the comment line in input file
	read(31,*)			 !reading the blank line in input file
	read(31,*)nsel		 !reading the operation option
	read(31,*)			 !reading the blank line in input file	
	read(31,*)			 !reading the comment line in input file
	read(31,*)			 !reading the blank line in input file

C	reading ranges of inputs for prediction
	do 45 i=1,nip
		read(31,*)(prip(i,j),j=1,2),prip_range(i) 
45	continue

C     Reading file option
      read(31,*)			 !reading the blank line in input file	
	read(31,*)			 !reading the comment line in input file
	read(31,*)			 !reading the blank line in input file	
	read(31,*)nopfl
      read(31,*)			 !reading the blank line in input file	
	read(31,*)			 !reading the comment line in input file
	read(31,*)			 !reading the blank line in input file	
		
	do 5 i=1,nip
	   read(31,*)(rip(i,j),j=1,2)   !reading ranges of inputs
 5    continue
	do 10 i=1,nop
	   read(31,*)(rop(i,j),j=1,2)   !reading ranges of outputs
 10   continue
 
      if((nsel.eq.1).OR.(nsel.eq.2))then
	read(31,*)					!reading the blank line in input file	
	read(31,*)					!reading the comment line in input file
	read(31,*)					!reading the blank line in input file		

C	Reading no. of data poitns and ranges of input and output parameters
	read(31,*)ntrndat,ntstdat	!reading number of training and test data 
	read(31,*)					!reading the blank line in input file	
	read(31,*)					!reading the comment line in input file
	read(31,*)					!reading the blank line in input file

C	Reading training input data
	do 15 i=1,ntrndat
		read(31,*)(xip(i,j),j=1,nip),(yop(i,k),k=1,nop)
 15   continue
 	read(31,*)					!reading the blank line in input file	
	read(31,*)					!reading the comment line in input file
	read(31,*)					!reading the blank line in input file

C	Reading testing input data
	do 20 i=1,ntstdat
		read(31,*)(testip(i,j),j=1,nip),(testop(i,k),k=1,nop)
 20   continue
 
      atestip(1:ntrndat,1:nip)=testip(1:ntrndat,1:nip)

C     Reading initial weights for IH and HO layer connections, 
c     learning rate, momentum constant, error threshold, maximum iterations

	read(31,*)				!reading the blank line in input file	
	read(31,*)				!reading the comment line in input file
	read(31,*)				!reading the blank line in input file
	read(31,*)znrm1,znrm2	!reading minm and maxm limit for normalization
      read(31,*)eta,alpha		!learning rate and momentum constant
      read(31,*)alpha1,beta	!initial values of regularisers
      read(31,*)niphd			!maxm hidden nodes = niphd*nip
      read(31,*)err_min		!threshold / convergence criteria
      read(31,*)iter_max		!maximum no. of iteration
	read(31,*)nadbias		!1.0 for bias
	read(31,*)lscale		!1.0 for log-scaling
	read(31,*)err_thresh	!Error threshold for an architecture
	inp_act=2

	if(lscale.eq.1)then		!Log scaling of data
	yop(1:ntrndat,1:nop)=log(yop(1:ntrndat,1:nop))
	rop(1:nop,1:2)=log(rop(1:nop,1:2))
	endif   
	      
c	Normalizing training data sets

      do 25 i=1,ntrndat
         do 30 j=1,nip
		    xnorm(i,j)=znrm1+(((xip(i,j))-rip(j,1))/(rip(j,2)-rip(j,1)))
     1						 *(znrm2-znrm1)
 30      continue
         do 35 j=1,nop
		    ynorm(i,j)=znrm1+(((yop(i,j))-rop(j,1))/(rop(j,2)-rop(j,1)))
     1						 *(znrm2-znrm1)
 35      continue
 25	continue
      do 40 i=1,ntstdat	  
		 testip(i,1:nip)=znrm1+(((testip(i,1:nip))-rip(1:nip,1))
     1						   /(rip(1:nip,2)-rip(1:nip,1)))*(znrm2-znrm1)     
 40   continue
      if (nadbias.eq.1.0) then
	   bias=1.0
	   nbias=1
	else
	   bias=0.0
	endif	
	endif
	
	close(31)
	RETURN
	END SUBROUTINE INPUT

C	--------------------------------------------------------------------
c	This subroutine reads the attributes like weights, hyperparameters
c	of trained network for prediction.
C	--------------------------------------------------------------------
	SUBROUTINE reread
	INCLUDE 'header.txt'

	hessian(1:500,1:500)=0.0
      ahessian(1:500,1:500)=0.0
      ahessianinv(1:500,1:500)=0.0
	
	if (nopfl.eq.1) open(unit=13,FILE='Al.txt')
	if (nopfl.eq.2) open(unit=13,FILE='Steel.txt')

C	Reading stored attributes of most suitable Neural-Network	
	read(13,*)nhid,nwts,nadbias,nbias	!No. of h/n nodes,total wts,biasoption
	read(13,*)
	read(13,*)bias					!bias value (1.0 or 0.0)
	read(13,*)
	read(13,*)eta,alpha				!learning rate, momentum transfer coeff.
	read(13,*)
	read(13,*)znrm1,znrm2				!Range min. & max.
	read(13,*)
	read(13,*)lscale
	read(13,*)
      read(13,9)wtbh(1:nhid)			!wts connecting bias-h/d nodes
      read(13,*)
      do 5 i=1,nip
		read(13,9)wtih(i,1:nhid)		!wts connecting i/p-h/d nodes
 5    continue   
      read(13,*) 
      do 10 i=1,nhid
		read(13,9)wtho(i,1:nop)	        !wts connecting h/d-o/p nodes
 10   continue  
      read(13,*)
      read(13,*)alpha1					!Weight regulariser
      read(13,*)
      read(13,*)beta					!Noise regulariser
      read(13,*)
	do 15 i=1,nwts
		read(13,9)ahessianinv(i,1:nwts)
 15	continue 
      if (lscale.eq.1) rop(1:nop,1:2)=log(rop(1:nop,1:2))

  9   format(<nwts>(F10.5,1x))       	           
	close(13)

	RETURN
	END SUBROUTINE reread